/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao;

import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaCombinacion;
import com.rjconsultores.ventaboletos.entidad.Tramo;
import java.util.List;

/**
 *
 * @author Rafius
 */
public interface RutaCombinacionDAO extends GenericDAO<RutaCombinacion, Integer> {

    public boolean busquedaRutaTramo(Ruta ruta, Tramo tramo, Boolean ativo);

    public RutaCombinacion busquedaTramoRutaTramo(Ruta ruta, Tramo trBuscaOrigemDestino);

    /**
     * Regreso el tramo de la entidade RutaCobinacion donde el tramo tines el origen-destino igual y la Rua sea la misma de RutaCombinacion
     * 
     * @param ruta
     * @param origen
     * @param destino
     * @return 
     */
    public Tramo busqueda(Ruta ruta, Parada origen, Parada destino);

    public RutaCombinacion busquedaTramoRutaOrigemDestino(Ruta ruta, Parada origem, Parada destino);

    public List<RutaCombinacion> obtenerPorRuta(Ruta ruta);

    public boolean buscarRutaCombinacionExisteTramo(Tramo tramo);

    /**
     * Hace una bsquena en los tramos faltantes en la combinacion de la ruta informada
     * @param rutaId
     * @return
     */
	List<Tramo> tramosFaltantes(Integer rutaId);
	
	
	public int borrarCombinaciones(Ruta ruta);
	
	public void activar(Ruta ruta, Tramo trBuscaOrigemDestino);
}
