/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.CategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("categoriaDAO")
public class CategoriaHibernateDAO extends GenericHibernateDAO<Categoria, Integer>
        implements CategoriaDAO {

    @Autowired
    public CategoriaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<Categoria> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("desccategoria"));

        return c.list();
    }

    public List<Categoria> buscar(String desccategoria) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("desccategoria", desccategoria));

        return c.list();
    }
}
