/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.ClasseServicoDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("claseServicioDAO")
public class ClasseServicoHibernateDAO extends GenericHibernateDAO<ClaseServicio, Short>
        implements ClasseServicoDAO {

    @Autowired
    public ClasseServicoHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<ClaseServicio> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("descclase"));

        return c.list();
    }

    public List<ClaseServicio> buscarPorNome(String nomeClaseServicio) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("descclase", nomeClaseServicio));

        return c.list();
    }
    public List<ClaseServicio> buscarTodosExceto(Integer ... idClase){
        Criteria c = this.makeCriteria();
        for (Integer id : idClase) {
            c.add(Restrictions.ne("claseservicioId", id.shortValue()));
        }
        c.add(Restrictions.eq("activo",Boolean.TRUE));
        c.addOrder(Order.asc("descclase"));

        return c.list();
    }
}
