/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.DiagramaAutobusDAO;
import com.rjconsultores.ventaboletos.entidad.DiagramaAutobus;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Administrador
 */
@Repository("diagramaAutobusDAO")
public class DiagramaAutobusHibernateDAO extends GenericHibernateDAO<DiagramaAutobus, Short>
        implements DiagramaAutobusDAO {

    @Autowired
    public DiagramaAutobusHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<DiagramaAutobus> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.addOrder(Order.asc("descDiagrama"));

        return c.list();
    }

    public List<DiagramaAutobus> buscar(String descDiagrama, Short maxparados,
            Short cantasientos) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("cantasientos", cantasientos));
        c.add(Restrictions.eq("maxparados", maxparados));
        c.add(Restrictions.eq("descDiagrama", descDiagrama));

        return c.list();
    }

    public List<DiagramaAutobus> buscar(String descDiagrama) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        c.add(Restrictions.eq("descDiagrama", descDiagrama));

        return c.list();
    }
}
