/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.PricingCategoriaDAO;
import com.rjconsultores.ventaboletos.entidad.Categoria;
import com.rjconsultores.ventaboletos.entidad.Pricing;
import com.rjconsultores.ventaboletos.entidad.PricingCategoria;
import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;

/**
 *
 * @author Rafius
 */
@Repository("pricingCategoriaDAO")
public class PricingCategoriaHibernateDAO extends GenericHibernateDAO<PricingCategoria, Integer>
        implements PricingCategoriaDAO {

    @Autowired
    public PricingCategoriaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    @Override
    public List<PricingCategoria> obtenerTodos() {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));

        return c.list();
    }

    public Boolean obtenerPricingCategoria(Pricing pricing, Categoria categoria) {
        Criteria c = getSession().createCriteria(getPersistentClass());
        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("pricing", pricing));
        c.add(Restrictions.eq("categoria", categoria));

        if (c.list().size() > 0) {
            return true;
        } else {
            return false;
        }
    }
}
