/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.dao.hibernate;

import com.rjconsultores.ventaboletos.dao.RutaSecuenciaDAO;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.entidad.RutaSecuencia;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

import java.util.List;
import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Repository;
import org.hibernate.criterion.Order;

/**
 *
 * @author Rafius
 */
@Repository("rutaSecuenciaDAO")
public class RutaSecuenciaHibernateDAO extends GenericHibernateDAO<RutaSecuencia, Integer>
        implements RutaSecuenciaDAO {

    @Autowired
    public RutaSecuenciaHibernateDAO(@Qualifier("sessionFactory") SessionFactory factory) {
        setSessionFactory(factory);
    }

    public List<RutaSecuencia> buscarSecuenciaOrdenado(Ruta ruta) {
        Criteria c = getSession().createCriteria(getPersistentClass());

        c.add(Restrictions.eq("activo", Boolean.TRUE));
        c.add(Restrictions.eq("ruta", ruta));

        c.addOrder(Order.asc("numsecuencia"));


        return c.list();
    }
    public int borrarSecuencias(Ruta ruta) {
    	Query query = this.getSession().createQuery("UPDATE RutaSecuencia SET activo = false, fecmodif =  current_timestamp(), usuarioId= :usuario where ruta = :ruta");
    	query.setParameter("usuario", UsuarioLogado.getUsuarioLogado().getUsuarioId());
    	query.setParameter("ruta", ruta);
    	
    	return query.executeUpdate();
    }
}
