/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.SequenceGenerator;

/**
 *
 * @author Administrador
 */
@Entity
@SequenceGenerator(name = "CATEGORIA_CORRIDA_SEQ", sequenceName = "CATEGORIA_CORRIDA_SEQ", allocationSize = 1)
@Table(name = "CATEGORIA_CORRIDA")
public class CategoriaCorrida implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CATEGORIA_CORRIDA_SEQ")
    @Column(name = "CATEGORIA_CORRIDA")
    private Integer categoriaCorrida;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "CORRIDA_ID", referencedColumnName = "CORRIDA_ID")
    @ManyToOne
    private CorridaCtrl corridaCtrl;
    @JoinColumn(name = "CATEGORIACTRL_ID", referencedColumnName = "CATEGORIACTRL_ID")
    @ManyToOne
    private CategoriaCtrl categoriaCtrl;

    public CategoriaCorrida() {
    }

    public CategoriaCorrida(Integer categoriaCorrida) {
        this.categoriaCorrida = categoriaCorrida;
    }

    public Integer getCategoriaCorrida() {
        return categoriaCorrida;
    }

    public void setCategoriaCorrida(Integer categoriaCorrida) {
        this.categoriaCorrida = categoriaCorrida;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public CorridaCtrl getCorridaCtrl() {
        return corridaCtrl;
    }

    public void setCorridaCtrl(CorridaCtrl corridaCtrl) {
        this.corridaCtrl = corridaCtrl;
    }

    public CategoriaCtrl getCategoriaCtrl() {
        return categoriaCtrl;
    }

    public void setCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        this.categoriaCtrl = categoriaCtrl;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final CategoriaCorrida other = (CategoriaCorrida) obj;
        if (this.corridaCtrl != other.corridaCtrl && (this.corridaCtrl == null || !this.corridaCtrl.equals(other.corridaCtrl))) {
            return false;
        }
        if (this.categoriaCtrl != other.categoriaCtrl && (this.categoriaCtrl == null || !this.categoriaCtrl.equals(other.categoriaCtrl))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 97 * hash + (this.corridaCtrl != null ? this.corridaCtrl.hashCode() : 0);
        hash = 97 * hash + (this.categoriaCtrl != null ? this.categoriaCtrl.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.CategoriaCorrida[categoriaCorrida=" + categoriaCorrida + "]";
    }
}
