/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

/**
 *
 * @author Shiro
 */
@Entity
@SequenceGenerator(name = "CORTESIA_SEQ", sequenceName = "CORTESIA_SEQ", allocationSize = 1)
@Table(name = "CORTESIA")
public class Cortesia implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "CORTESIA_SEQ")
    @Column(name = "CORTESIA_ID")
    private Integer cortesiaId;
    @Column(name = "DESCCORREO")
    private String descCorreo;
    @Column(name = "INDTIPOVIAJE")
    private String indtipoviaje;
    @Column(name = "FECINICIOVIGENCIA")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecinicio;
    @Column(name = "FECFINVIGENCIA")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecfinal;
    @Column(name = "NDSTATUS")
    private String ndstatus;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "EMPLEADO_ID")
    @OneToOne
    private Empleado empleado;
    @JoinColumn(name = "TIPOCORTESIA_ID", referencedColumnName = "TIPOCORTESIA_ID")
    @ManyToOne
    private TipoCortesia tipoCortesia;
    @JoinColumn(name = "MARCA_ID", referencedColumnName = "MARCA_ID")
    @ManyToOne
    private Marca marca;
    @JoinColumn(name = "CLASESERVICIO_ID", referencedColumnName = "CLASESERVICIO_ID")
    @ManyToOne
    private ClaseServicio claseServicio;
    @JoinColumn(name = "ORIGEN_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada origem;
    @JoinColumn(name = "DESTINO_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada destino;
    @JoinColumn(name = "MOTIVOVIAJE_ID", referencedColumnName = "MOTIVOVIAJE_ID")
    @ManyToOne
    private MotivoViaje motivoViaje;
    @OneToMany(mappedBy = "cortesia", cascade = CascadeType.ALL)
    @LazyCollection(value = LazyCollectionOption.FALSE)
    private List<CortesiaBeneficiario> cortesiaBeneficiarioList;

    public MotivoViaje getMotivoViaje() {
        return motivoViaje;
    }

    public void setMotivoViaje(MotivoViaje motivoViaje) {
        this.motivoViaje = motivoViaje;
    }

    public List<CortesiaBeneficiario> getCortesiaBeneficiarioList() {
        List<CortesiaBeneficiario> cb = new ArrayList<CortesiaBeneficiario>();
        if (cortesiaBeneficiarioList != null) {
            for (CortesiaBeneficiario ctb : this.cortesiaBeneficiarioList) {
                if (ctb.getActivo() == Boolean.TRUE) {
                    cb.add(ctb);
                }
            }
        }

        this.cortesiaBeneficiarioList = cb;

        return cb;
    }

    public void setCortesiaBeneficiarioList(List<CortesiaBeneficiario> cortesiaBeneficiarioList) {
        this.cortesiaBeneficiarioList = cortesiaBeneficiarioList;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    public Integer getCortesiaId() {
        return cortesiaId;
    }

    public void setCortesiaId(Integer cortesiaId) {
        this.cortesiaId = cortesiaId;
    }

    public String getDescCorreo() {
        return descCorreo;
    }

    public void setDescCorreo(String descCorreo) {
        this.descCorreo = descCorreo;
    }

    public Parada getDestino() {
        return destino;
    }

    public void setDestino(Parada destino) {
        this.destino = destino;
    }

    public Empleado getEmpleado() {
        return empleado;
    }

    public void setEmpleado(Empleado empleado) {
        this.empleado = empleado;
    }

    public Date getFecfinal() {
        return fecfinal;
    }

    public void setFecfinal(Date fecfinal) {
        this.fecfinal = fecfinal;
    }

    public Date getFecinicio() {
        return fecinicio;
    }

    public void setFecinicio(Date fecinicio) {
        this.fecinicio = fecinicio;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public String getIndtipoviaje() {
        return indtipoviaje;
    }

    public void setIndtipoviaje(String indtipoviaje) {
        this.indtipoviaje = indtipoviaje;
    }

    public Marca getMarca() {
        return marca;
    }

    public void setMarca(Marca marca) {
        this.marca = marca;
    }

    public String getNdstatus() {
        return ndstatus;
    }

    public void setNdstatus(String ndstatus) {
        this.ndstatus = ndstatus;
    }

    public Parada getOrigem() {
        return origem;
    }

    public void setOrigem(Parada origem) {
        this.origem = origem;
    }

    public TipoCortesia getTipoCortesia() {
        return tipoCortesia;
    }

    public void setTipoCortesia(TipoCortesia tipoCortesia) {
        this.tipoCortesia = tipoCortesia;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (cortesiaId != null ? cortesiaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Cortesia)) {
            return false;
        }
        Cortesia other = (Cortesia) object;
        if ((this.cortesiaId == null && other.cortesiaId != null) || (this.cortesiaId != null && !this.cortesiaId.equals(other.cortesiaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.entidad.Cortesia[cortesiaId=" + cortesiaId + "]";
        //return this.getEmpleado() + getDescCorreo();
    }
}
