/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PARAM_ACUMULA_PUNTO_SEQ", sequenceName = "PARAM_ACUMULA_PUNTO_SEQ", allocationSize = 1)
@Table(name = "PARAM_ACUMULA_PUNTO")
public class ParamAcumulaPunto implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PARAM_ACUMULA_PUNTO_SEQ")
    @Column(name = "PARAMACUMULAPUNTO_ID")
    private Integer paramacumulapuntoId;
    @Column(name = "CANTOPERACIONDIA")
    private Short cantoperaciondia;
    @Column(name = "CANTBOLETOOPERACION")
    private Integer cantboletooperacion;
    @Column(name = "FECINICIOVIGENCIA")
    @Temporal(TemporalType.TIMESTAMP)
    private Date feciniciovigencia;
    @Column(name = "FECFINVIGENCIA")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecfinvigencia;
    @Column(name = "PORCCLIENTE")
    private BigDecimal porccliente;
    @Column(name = "PORCEMPRESA")
    private BigDecimal porcempresa;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "DESTINO_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada destino;
    @JoinColumn(name = "ORIGEN_ID", referencedColumnName = "PARADA_ID")
    @ManyToOne
    private Parada origem;
    @JoinColumn(name = "FORMAPAGO_ID", referencedColumnName = "FORMAPAGO_ID")
    @ManyToOne
    private FormaPago formaPago;
    @JoinColumn(name = "EMPRESA_ID", referencedColumnName = "EMPRESA_ID")
    @ManyToOne
    private Empresa empresa;
    @JoinColumn(name = "CATEGORIA_ID", referencedColumnName = "CATEGORIA_ID")
    @ManyToOne
    private Categoria categoria;

    public ParamAcumulaPunto() {
    }

    public ParamAcumulaPunto(Integer paramacumulapuntoId) {
        this.paramacumulapuntoId = paramacumulapuntoId;
    }

    public Integer getParamacumulapuntoId() {
        return paramacumulapuntoId;
    }

    public void setParamacumulapuntoId(Integer paramacumulapuntoId) {
        this.paramacumulapuntoId = paramacumulapuntoId;
    }

    public Short getCantoperaciondia() {
        return cantoperaciondia;
    }

    public void setCantoperaciondia(Short cantoperaciondia) {
        this.cantoperaciondia = cantoperaciondia;
    }

    public Integer getCantboletooperacion() {
        return cantboletooperacion;
    }

    public void setCantboletooperacion(Integer cantboletooperacion) {
        this.cantboletooperacion = cantboletooperacion;
    }

    public Date getFeciniciovigencia() {
        return feciniciovigencia;
    }

    public void setFeciniciovigencia(Date feciniciovigencia) {
        this.feciniciovigencia = feciniciovigencia;
    }

    public Date getFecfinvigencia() {
        return fecfinvigencia;
    }

    public void setFecfinvigencia(Date fecfinvigencia) {
        this.fecfinvigencia = fecfinvigencia;
    }

    public BigDecimal getPorccliente() {
        return porccliente;
    }

    public void setPorccliente(BigDecimal porccliente) {
        this.porccliente = porccliente;
    }

    public BigDecimal getPorcempresa() {
        return porcempresa;
    }

    public void setPorcempresa(BigDecimal porcempresa) {
        this.porcempresa = porcempresa;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Parada getDestino() {
        return destino;
    }

    public void setDestino(Parada destino) {
        this.destino = destino;
    }

    public Parada getOrigem() {
        return origem;
    }

    public void setOrigem(Parada origem) {
        this.origem = origem;
    }

    public FormaPago getFormaPago() {
        return formaPago;
    }

    public void setFormaPago(FormaPago formaPago) {
        this.formaPago = formaPago;
    }

    public Empresa getEmpresa() {
        return empresa;
    }

    public void setEmpresa(Empresa empresa) {
        this.empresa = empresa;
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (paramacumulapuntoId != null ? paramacumulapuntoId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ParamAcumulaPunto)) {
            return false;
        }
        ParamAcumulaPunto other = (ParamAcumulaPunto) object;
        if ((this.paramacumulapuntoId == null && other.paramacumulapuntoId != null) || (this.paramacumulapuntoId != null && !this.paramacumulapuntoId.equals(other.paramacumulapuntoId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "novasEntidades.ParamAcumulaPunto[paramacumulapuntoId=" + paramacumulapuntoId + "]";
    }
}
