/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PRICING_OCUPACION_SEQ", sequenceName = "PRICING_OCUPACION_SEQ", allocationSize = 1)
@Table(name = "PRICING_OCUPACION")
public class PricingOcupacion implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PRICING_OCUPACION_SEQ")
    @Column(name = "PRICINGOCUPACION_ID")
    private Integer pricingocupacionId;
    @Column(name = "OCUPACIONINICIAL")
    private BigDecimal ocupacioninicial;
    @Column(name = "OCUPACIONFINAL")
    private BigDecimal ocupacionfinal;
    @Column(name = "PORCENTAJE")
    private BigDecimal porcentaje;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "PRICING_ID", referencedColumnName = "PRICING_ID")
    @ManyToOne
    private Pricing pricing;

    public PricingOcupacion() {
    }

    public PricingOcupacion(Integer pricingocupacionId) {
        this.pricingocupacionId = pricingocupacionId;
    }

    public Integer getPricingocupacionId() {
        return pricingocupacionId;
    }

    public void setPricingocupacionId(Integer pricingocupacionId) {
        this.pricingocupacionId = pricingocupacionId;
    }

    public BigDecimal getOcupacioninicial() {
        return ocupacioninicial;
    }

    public void setOcupacioninicial(BigDecimal ocupacioninicial) {
        this.ocupacioninicial = ocupacioninicial;
    }

    public BigDecimal getOcupacionfinal() {
        return ocupacionfinal;
    }

    public void setOcupacionfinal(BigDecimal ocupacionfinal) {
        this.ocupacionfinal = ocupacionfinal;
    }

    public BigDecimal getPorcentaje() {
        return porcentaje;
    }

    public void setPorcentaje(BigDecimal porcentaje) {
        this.porcentaje = porcentaje;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Pricing getPricing() {
        return pricing;
    }

    public void setPricing(Pricing pricing) {
        this.pricing = pricing;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (pricingocupacionId != null ? pricingocupacionId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof PricingOcupacion)) {
            return false;
        }
        PricingOcupacion other = (PricingOcupacion) object;
        if ((this.pricingocupacionId == null && other.pricingocupacionId != null) || (this.pricingocupacionId != null && !this.pricingocupacionId.equals(other.pricingocupacionId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "entidad.test.PricingOcupacion[pricingocupacionId=" + pricingocupacionId + "]";
    }
}
