/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "PROD_VIGENCIA_SEQ", sequenceName = "PROD_VIGENCIA_SEQ", allocationSize = 1)
@Table(name = "PROD_VIGENCIA")
public class ProdVigencia implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "PROD_VIGENCIA_SEQ")
    @Basic(optional = false)
    @Column(name = "PRODVIGENCIA_ID")
    private Integer prodvigenciaId;
    @Column(name = "FECVIGENCIAINICIO")
    @Temporal(TemporalType.DATE)
    private Date fecvigenciainicio;
    @Column(name = "FECVIGENCIAFIN")
    @Temporal(TemporalType.DATE)
    private Date fecvigenciafin;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "PRODUCTOSERVICIO_ID", referencedColumnName = "PRODUCTOSERVICIO_ID")
    @ManyToOne
    private ProductoServicio productoServicio;

    public ProdVigencia() {
    }

    public ProdVigencia(Integer prodvigenciaId) {
        this.prodvigenciaId = prodvigenciaId;
    }

    public Integer getProdvigenciaId() {
        return prodvigenciaId;
    }

    public void setProdvigenciaId(Integer prodvigenciaId) {
        this.prodvigenciaId = prodvigenciaId;
    }

    public Date getFecvigenciainicio() {
        return fecvigenciainicio;
    }

    public void setFecvigenciainicio(Date fecvigenciainicio) {
        this.fecvigenciainicio = fecvigenciainicio;
    }

    public Date getFecvigenciafin() {
        return fecvigenciafin;
    }

    public void setFecvigenciafin(Date fecvigenciafin) {
        this.fecvigenciafin = fecvigenciafin;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public ProductoServicio getProductoServicio() {
        return productoServicio;
    }

    public void setProductoServicio(ProductoServicio productoServicio) {
        this.productoServicio = productoServicio;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (prodvigenciaId != null ? prodvigenciaId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ProdVigencia)) {
            return false;
        }
        ProdVigencia other = (ProdVigencia) object;
        if ((this.prodvigenciaId == null && other.prodvigenciaId != null) || (this.prodvigenciaId != null && !this.prodvigenciaId.equals(other.prodvigenciaId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.rjconsultores.ventaboletos.utilerias.ProdVigencia[prodvigenciaId=" + prodvigenciaId + "]";
    }
}
