/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.entidad;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import javax.persistence.Basic;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author Rafius
 */
@Entity
@SequenceGenerator(name = "TRAMO_SERVICIO_SEQ", sequenceName = "TRAMO_SERVICIO_SEQ", allocationSize = 1)
@Table(name = "TRAMO_SERVICIO")
public class TramoServicio implements Serializable {

    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @GeneratedValue(strategy = GenerationType.AUTO, generator = "TRAMO_SERVICIO_SEQ")
    @Column(name = "TRAMOSERVICIO_ID")
    private Integer tramoservicioId;
    @Column(name = "TIEMPORECORRIDO")
    @Temporal(TemporalType.TIMESTAMP)
    private Date tiemporecorrido;
    @Column(name = "ACTIVO")
    private Boolean activo;
    @Column(name = "FECMODIF")
    @Temporal(TemporalType.TIMESTAMP)
    private Date fecmodif;
    @Column(name = "USUARIO_ID")
    private Integer usuarioId;
    @JoinColumn(name = "TRAMO_ID", referencedColumnName = "TRAMO_ID")
    @ManyToOne
    private Tramo tramo;
    @JoinColumn(name = "CLASESERVICIO_ID", referencedColumnName = "CLASESERVICIO_ID")
    @ManyToOne
    private ClaseServicio claseServicio;

    public TramoServicio() {
    }

    public TramoServicio(Integer tramoservicioId) {
        this.tramoservicioId = tramoservicioId;
    }

    public Integer getTramoservicioId() {
        return tramoservicioId;
    }

    public void setTramoservicioId(Integer tramoservicioId) {
        this.tramoservicioId = tramoservicioId;
    }

    public Date getTiemporecorrido() {
        return tiemporecorrido;
    }

    public void setTiemporecorrido(Date tiemporecorrido) {
        this.tiemporecorrido = tiemporecorrido;
    }

    public Boolean getActivo() {
        return activo;
    }

    public void setActivo(Boolean activo) {
        this.activo = activo;
    }

    public Date getFecmodif() {
        return fecmodif;
    }

    public void setFecmodif(Date fecmodif) {
        this.fecmodif = fecmodif;
    }

    public Integer getUsuarioId() {
        return usuarioId;
    }

    public void setUsuarioId(Integer usuarioId) {
        this.usuarioId = usuarioId;
    }

    public Tramo getTramo() {
        return tramo;
    }

    public void setTramo(Tramo tramo) {
        this.tramo = tramo;
    }

    public ClaseServicio getClaseServicio() {
        return claseServicio;
    }

    public void setClaseServicio(ClaseServicio claseServicio) {
        this.claseServicio = claseServicio;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final TramoServicio other = (TramoServicio) obj;
        if (this.activo != other.activo && (this.activo == null || !this.activo.equals(other.activo))) {
            return false;
        }
        if (this.tramo != other.tramo && (this.tramo == null || !this.tramo.equals(other.tramo))) {
            return false;
        }
        if (this.claseServicio != other.claseServicio && (this.claseServicio == null || !this.claseServicio.equals(other.claseServicio))) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        return hash;
    }

    @Override
    public String toString() {
        return "teste.TramoServicio[tramoservicioId=" + tramoservicioId + "]";
    }
}
