/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.EsquemaAsientoDAO;
import com.rjconsultores.ventaboletos.entidad.EsquemaAsiento;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.service.EsquemaAsientoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("esquemaAsientoService")
public class EsquemaAsientoServiceImpl implements EsquemaAsientoService {

    @Autowired
    private EsquemaAsientoDAO esquemaAsientoDAO;

    public List<EsquemaAsiento> obtenerTodos() {
        return esquemaAsientoDAO.obtenerTodos();
    }

    public EsquemaAsiento obtenerID(Integer id) {
        return esquemaAsientoDAO.obtenerID(id);
    }

    @Transactional
    public EsquemaAsiento suscribir(EsquemaAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaAsientoDAO.suscribir(entidad);
    }

    @Transactional
    public EsquemaAsiento actualizacion(EsquemaAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return esquemaAsientoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(EsquemaAsiento entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        esquemaAsientoDAO.actualizacion(entidad);
    }

    public List<EsquemaAsiento> obtenerPorCorrida(EsquemaCorrida esquemaCorrida) {
        return esquemaAsientoDAO.obtenerPorCorrida(esquemaCorrida);
    }

    public EsquemaAsiento obtenerPorCorridaeAsiento(EsquemaCorrida esquemaCorrida, String asiento) {
        return esquemaAsientoDAO.obtenerPorCorridaeAsiento(esquemaCorrida, asiento);
    }
}
