/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.MonedaDAO;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Rafius
 */
@Service("monedaService")
public class MonedaServiceImpl implements MonedaService {

    @Autowired
    private MonedaDAO monedaDAO;

    public List<Moneda> obtenerTodos() {
        return monedaDAO.obtenerTodos();
    }

    public Moneda obtenerID(Integer id) {
        return monedaDAO.obtenerID(id);
    }

    @Transactional
    public Moneda suscribir(Moneda entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return monedaDAO.suscribir(entidad);
    }

    @Transactional
    public Moneda actualizacion(Moneda entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return monedaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Moneda entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        monedaDAO.actualizacion(entidad);
    }

    public List<Moneda> buscar(String descmoneda) {
        return monedaDAO.buscar(descmoneda);
    }

  
}
