/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.NodoDAO;
import com.rjconsultores.ventaboletos.entidad.Nodo;
import com.rjconsultores.ventaboletos.service.NodoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("nodoService")
public class NodoServiceImpl implements NodoService {

    @Autowired
    private NodoDAO nodoDAO;

    public List<Nodo> obtenerTodos() {
        return nodoDAO.obtenerTodos();
    }

    public Nodo obtenerID(Integer id) {
        return nodoDAO.obtenerID(id);
    }

    @Transactional
    public Nodo suscribir(Nodo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return nodoDAO.suscribir(entidad);
    }

    @Transactional
    public Nodo actualizacion(Nodo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return nodoDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Nodo entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        nodoDAO.actualizacion(entidad);
    }
}
