/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.ParadaDAO;
import com.rjconsultores.ventaboletos.dao.TramoDAO;
import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Nodo;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.TipoParada;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("paradaService")
public class ParadaServiceImpl implements ParadaService {

    @Autowired
    private ParadaDAO paradaDAO;
    @Autowired
    private TramoDAO tramoDAO;

    public List<Parada> obtenerTodos() {
        return paradaDAO.obtenerTodos();
    }

    public Parada obtenerID(Integer id) {
        return paradaDAO.obtenerID(id);
    }

    @Transactional
    public Parada suscribir(Parada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paradaDAO.suscribir(entidad);
    }

    @Transactional
    public Parada actualizacion(Parada entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return paradaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Parada entidad) throws RegistroConDependenciaException {
        if ((tramoDAO.count("origem", entidad) > 0l)
                || (tramoDAO.count("destino", entidad) > 0l)) {
            throw new RegistroConDependenciaException();
        }
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        paradaDAO.actualizacion(entidad);
    }

    public List<Parada> buscar(String descparada, String cveparada, Ciudad ciudad,
            TipoParada tipoParada, Nodo nodo) {
        return paradaDAO.buscar(descparada, cveparada, ciudad, tipoParada, nodo);
    }

    public List<Parada> buscar(String descparada) {
        return paradaDAO.buscar(descparada);
    }

    public List<Parada> buscarCVE(String cveparada) {
        return paradaDAO.buscarCVE(cveparada);
    }

    public List<Parada> buscaLike(String descparada) {
        return paradaDAO.buscaLike(descparada);
    }
}
