/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.PerfilDAO;
import com.rjconsultores.ventaboletos.entidad.Perfil;
import com.rjconsultores.ventaboletos.service.PerfilService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author rodrigo
 */
@Service("perfilService")
public class PerfilServiceImpl implements PerfilService {

    @Autowired
    private PerfilDAO perfilDAO;

    public List<Perfil> obtenerTodos() {
        return perfilDAO.obtenerTodos();
    }

    public Perfil obtenerID(Integer id) {
        return perfilDAO.obtenerID(id);
    }

    @Transactional
    public Perfil suscribir(Perfil entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return perfilDAO.suscribir(entidad);
    }

    @Transactional
    public Perfil actualizacion(Perfil entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return perfilDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(Perfil entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        perfilDAO.actualizacion(entidad);
    }

    public List<Perfil> buscar(String dscPerfil) {
        return perfilDAO.buscar(dscPerfil);
    }
}
